"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jsrsasign = require("jsrsasign");

var _jsrsasign2 = _interopRequireDefault(_jsrsasign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Key = function () {
	function Key(jwt) {
		_classCallCheck(this, Key);

		this.jwt = jwt;
	}

	_createClass(Key, [{
		key: "isValid",
		value: function isValid(token) {
			return _jsrsasign2.default.jws.JWS.verify(this.jwt, { rstr: token }, ["HS256"]);
		}
	}, {
		key: "username",
		get: function get() {
			var obj = _jsrsasign2.default.jws.JWS.parse(this.jwt);
			return obj.payloadObj.iss;
		}
	}, {
		key: "value",
		get: function get() {
			return this.jwt;
		}
	}], [{
		key: "generate",
		value: function generate(username, token) {
			var oHeader = { alg: "HS256", typ: "JWT" };
			var oPayload = {};
			var time = _jsrsasign2.default.jws.IntDate.get('now');

			oPayload.iss = username;
			oPayload.iat = time;

			var sHeader = JSON.stringify(oHeader);
			var sPayload = JSON.stringify(oPayload);

			return new Key(_jsrsasign2.default.jws.JWS.sign(oHeader.alg, sHeader, sPayload, { rstr: token }));
		}
	}]);

	return Key;
}();

exports.default = Key;