'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jsrsasign = require('jsrsasign');

var _jsrsasign2 = _interopRequireDefault(_jsrsasign);

var _Encrypt = require('./Encrypt');

var _Encrypt2 = _interopRequireDefault(_Encrypt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Sign = function () {
	function Sign(jwt) {
		_classCallCheck(this, Sign);

		this.jwt = jwt;
	}

	_createClass(Sign, [{
		key: 'isValid',
		value: function isValid(token) {
			return _jsrsasign2.default.jws.JWS.verify(this.jwt, { rstr: this.issuer + token }, ["HS256"]);
		}
	}, {
		key: 'issuer',
		get: function get() {
			var obj = _jsrsasign2.default.jws.JWS.parse(this.jwt);
			return obj.payloadObj.iss;
		}
	}, {
		key: 'value',
		get: function get() {
			return this.jwt;
		}
	}], [{
		key: 'generate',
		value: function generate(uri, method, content, issuer, token) {
			if (!content) content = "";else content = JSON.stringify(content);

			var oHeader = { alg: "HS256", typ: "JWT" };
			var oPayload = {};
			var time = _jsrsasign2.default.jws.IntDate.get('now') + 5;
			let dif = issuer.dif;
			let exp = parseInt(((time * 1000) + time) / 1000)

			console.log(exp)

			oPayload.exp = exp;
			oPayload.iss = issuer.value;
			oPayload.aud = uri;
			oPayload.sub = method;
			oPayload.jti = _Encrypt2.default.md5(content);

			var sHeader = JSON.stringify(oHeader);
			var sPayload = JSON.stringify(oPayload);

			return new Sign(_jsrsasign2.default.jws.JWS.sign(oHeader.alg, sHeader, sPayload, { rstr: issuer.value + token }));
		}
	}]);

	return Sign;
}();

exports.default = Sign;